Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Views/3.3/CrossValidationView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Views/3.3/CrossValidationView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis.Views/3.3/CrossValidationView.Designer.cs	(revision 5466)
@@ -61,8 +61,8 @@
       this.samplesEndStringConvertibleValueView = new HeuristicLab.Data.Views.StringConvertibleValueView();
       this.samplesStartStringConvertibleValueView = new HeuristicLab.Data.Views.StringConvertibleValueView();
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.algorithmTabPage = new System.Windows.Forms.TabPage();
       this.algorithmNamedItemView = new HeuristicLab.Core.Views.NamedItemView();
-      this.algorithmTabControl = new System.Windows.Forms.TabControl();
+      this.algorithmTabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.algorithmProblemTabPage = new System.Windows.Forms.TabPage();
       this.openProblemButton = new System.Windows.Forms.Button();
@@ -596,5 +596,5 @@
     private Data.Views.StringConvertibleValueView samplesEndStringConvertibleValueView;
     private System.Windows.Forms.Label samplesEndLabel;
-    private System.Windows.Forms.TabControl tabControl;
+    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     private System.Windows.Forms.TabPage algorithmTabPage;
     private System.Windows.Forms.TabPage resultsTabPage;
@@ -602,5 +602,5 @@
     private System.Windows.Forms.Button newAlgorithmButton;
     private Core.Views.NamedItemView algorithmNamedItemView;
-    private System.Windows.Forms.TabControl algorithmTabControl;
+    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl algorithmTabControl;
     private System.Windows.Forms.TabPage algorithmProblemTabPage;
     private System.Windows.Forms.TabPage algorithmParametersTabPage;
Index: /trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.Designer.cs	(revision 5466)
@@ -56,5 +56,5 @@
       this.compileButton = new System.Windows.Forms.Button();
       this.codeEditor = new HeuristicLab.CodeEditor.CodeEditor();
-      this.tabControl1 = new System.Windows.Forms.TabControl();
+      this.tabControl1 = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.tabPage1 = new System.Windows.Forms.TabPage();
       this.parameterCollectionView = new HeuristicLab.Core.Views.ParameterCollectionView();
@@ -317,5 +317,5 @@
     #endregion
 
-    private System.Windows.Forms.TabControl tabControl1;
+    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl1;
     private System.Windows.Forms.TabPage tabPage1;
     private HeuristicLab.Core.Views.ParameterCollectionView parameterCollectionView;
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/AlgorithmOperatorView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/AlgorithmOperatorView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/AlgorithmOperatorView.Designer.cs	(revision 5466)
@@ -45,5 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.parametersTabPage = new System.Windows.Forms.TabPage();
       this.parameterCollectionView = new HeuristicLab.Core.Views.ParameterCollectionView();
@@ -173,5 +173,5 @@
     #endregion
 
-    protected System.Windows.Forms.TabControl tabControl;
+    protected HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     protected System.Windows.Forms.TabPage parametersTabPage;
     protected System.Windows.Forms.TabPage operatorGraphTabPage;
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/CheckedMultiOperatorView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/CheckedMultiOperatorView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/CheckedMultiOperatorView.Designer.cs	(revision 5466)
@@ -45,5 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.operatorsTabPage = new System.Windows.Forms.TabPage();
       this.operatorListView = new HeuristicLab.Core.Views.CheckedItemListView<T>();
@@ -172,5 +172,5 @@
     #endregion
 
-    protected System.Windows.Forms.TabControl tabControl;
+    protected HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     protected System.Windows.Forms.TabPage operatorsTabPage;
     protected System.Windows.Forms.TabPage parametersTabPage;
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/MultiOperatorView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/MultiOperatorView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/MultiOperatorView.Designer.cs	(revision 5466)
@@ -45,5 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.operatorsTabPage = new System.Windows.Forms.TabPage();
       this.operatorListView = new HeuristicLab.Core.Views.ItemListView<T>();
@@ -172,5 +172,5 @@
     #endregion
 
-    protected System.Windows.Forms.TabControl tabControl;
+    protected HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     protected System.Windows.Forms.TabPage operatorsTabPage;
     protected System.Windows.Forms.TabPage parametersTabPage;
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/ValuesCollectorView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/ValuesCollectorView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/ValuesCollectorView.Designer.cs	(revision 5466)
@@ -45,5 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.collectedValuesTabPage = new System.Windows.Forms.TabPage();
       this.collectedValuesView = new HeuristicLab.Core.Views.ParameterCollectionView();
@@ -172,5 +172,5 @@
     #endregion
 
-    protected System.Windows.Forms.TabControl tabControl;
+    protected HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     protected System.Windows.Forms.TabPage collectedValuesTabPage;
     protected System.Windows.Forms.TabPage parametersTabPage;
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.Designer.cs	(revision 5466)
@@ -34,5 +34,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.problemTabPage = new System.Windows.Forms.TabPage();
       this.problemViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
@@ -340,5 +340,5 @@
     #endregion
 
-    protected System.Windows.Forms.TabControl tabControl;
+    protected HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     protected System.Windows.Forms.TabPage parametersTabPage;
     protected System.Windows.Forms.TabPage problemTabPage;
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.Designer.cs	(revision 5466)
@@ -34,5 +34,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.optimizerTabPage = new System.Windows.Forms.TabPage();
       this.optimizerViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
@@ -302,5 +302,5 @@
     #endregion
 
-    private System.Windows.Forms.TabControl tabControl;
+    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     private System.Windows.Forms.TabPage optimizerTabPage;
     private HeuristicLab.MainForm.WindowsForms.ViewHost optimizerViewHost;
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/ExperimentView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/ExperimentView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/ExperimentView.Designer.cs	(revision 5466)
@@ -46,5 +46,5 @@
     private void InitializeComponent() {
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ExperimentView));
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.optimizersTabPage = new System.Windows.Forms.TabPage();
       this.optimizerListView = new HeuristicLab.Optimization.Views.OptimizerListView();
@@ -232,5 +232,5 @@
     #endregion
 
-    private System.Windows.Forms.TabControl tabControl;
+    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     private System.Windows.Forms.TabPage optimizersTabPage;
     private System.Windows.Forms.Button startButton;
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.Designer.cs	(revision 5466)
@@ -61,5 +61,5 @@
       this.itemsGroupBox = new System.Windows.Forms.GroupBox();
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.runPage = new System.Windows.Forms.TabPage();
       this.constraintPage = new System.Windows.Forms.TabPage();
@@ -308,5 +308,5 @@
     private ToolStrip toolStrip;
     private ToolStripDropDownButton analyzeRunsToolStripDropDownButton;
-    private TabControl tabControl;
+    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     private TabPage runPage;
     private TabPage constraintPage;
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/DataAnalysisSolutionView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/DataAnalysisSolutionView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/DataAnalysisSolutionView.Designer.cs	(revision 5466)
@@ -48,5 +48,5 @@
       this.modelTabPage = new System.Windows.Forms.TabPage();
       this.modelViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.dataTabPage.SuspendLayout();
       this.modelTabPage.SuspendLayout();
@@ -135,5 +135,5 @@
     #endregion
 
-    protected System.Windows.Forms.TabControl tabControl;
+    protected HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     protected System.Windows.Forms.TabPage dataTabPage;
     protected System.Windows.Forms.TabPage modelTabPage;
Index: /trunk/sources/HeuristicLab.Problems.ExternalEvaluation.GP.Views/3.3/VariableSymbolView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.ExternalEvaluation.GP.Views/3.3/VariableSymbolView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Problems.ExternalEvaluation.GP.Views/3.3/VariableSymbolView.Designer.cs	(revision 5466)
@@ -24,5 +24,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.variableNamesTabPage = new System.Windows.Forms.TabPage();
       this.parametersTabPage = new System.Windows.Forms.TabPage();
@@ -209,5 +209,5 @@
     #endregion
 
-    private System.Windows.Forms.TabControl tabControl;
+    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     private System.Windows.Forms.TabPage variableNamesTabPage;
     private System.Windows.Forms.TabPage parametersTabPage;
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions.Views/3.3/SingleObjectiveTestFunctionSolutionView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions.Views/3.3/SingleObjectiveTestFunctionSolutionView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions.Views/3.3/SingleObjectiveTestFunctionSolutionView.Designer.cs	(revision 5466)
@@ -50,5 +50,5 @@
       this.groupBox4 = new System.Windows.Forms.GroupBox();
       this.realVectorView = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      this.tabControl1 = new System.Windows.Forms.TabControl();
+      this.tabControl1 = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.textualTabPage = new System.Windows.Forms.TabPage();
       this.graphicalTabPage = new System.Windows.Forms.TabPage();
@@ -224,5 +224,5 @@
     private System.Windows.Forms.GroupBox groupBox3;
     private HeuristicLab.MainForm.WindowsForms.ViewHost realVectorView;
-    private System.Windows.Forms.TabControl tabControl1;
+    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl1;
     private System.Windows.Forms.TabPage textualTabPage;
     private System.Windows.Forms.TabPage graphicalTabPage;
Index: /trunk/sources/HeuristicLab.Problems.TravelingSalesman.Views/3.3/PathTSPTourView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TravelingSalesman.Views/3.3/PathTSPTourView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Problems.TravelingSalesman.Views/3.3/PathTSPTourView.Designer.cs	(revision 5466)
@@ -46,5 +46,5 @@
     private void InitializeComponent() {
       this.pictureBox = new System.Windows.Forms.PictureBox();
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.visualizationTabPage = new System.Windows.Forms.TabPage();
       this.valueTabPage = new System.Windows.Forms.TabPage();
@@ -207,5 +207,5 @@
 
     private System.Windows.Forms.PictureBox pictureBox;
-    private System.Windows.Forms.TabControl tabControl;
+    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     private System.Windows.Forms.TabPage visualizationTabPage;
     private System.Windows.Forms.TabPage valueTabPage;
Index: /trunk/sources/HeuristicLab.Problems.TravelingSalesman.Views/3.3/TravelingSalesmanProblemView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TravelingSalesman.Views/3.3/TravelingSalesmanProblemView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Problems.TravelingSalesman.Views/3.3/TravelingSalesmanProblemView.Designer.cs	(revision 5466)
@@ -35,5 +35,5 @@
     private void InitializeComponent() {
       this.importButton = new System.Windows.Forms.Button();
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.parametersTabPage = new System.Windows.Forms.TabPage();
       this.parameterCollectionView = new HeuristicLab.Core.Views.ParameterCollectionView();
@@ -153,5 +153,5 @@
 
     private System.Windows.Forms.Button importButton;
-    private System.Windows.Forms.TabControl tabControl;
+    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     private System.Windows.Forms.TabPage parametersTabPage;
     private System.Windows.Forms.TabPage visualizationTabPage;
Index: /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/VRPSolutionView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/VRPSolutionView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/VRPSolutionView.Designer.cs	(revision 5466)
@@ -45,5 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.visualizationTabPage = new System.Windows.Forms.TabPage();
       this.pictureBox = new System.Windows.Forms.PictureBox();
@@ -146,5 +146,5 @@
     #endregion
 
-    private System.Windows.Forms.TabControl tabControl;
+    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
     private System.Windows.Forms.TabPage visualizationTabPage;
     private System.Windows.Forms.PictureBox pictureBox;
Index: /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/VehicleRoutingProblemView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/VehicleRoutingProblemView.Designer.cs	(revision 5465)
+++ /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/VehicleRoutingProblemView.Designer.cs	(revision 5466)
@@ -25,5 +25,5 @@
     private void InitializeComponent() {
       this.importButton = new System.Windows.Forms.Button();
-      this.tabControl1 = new System.Windows.Forms.TabControl();
+      this.tabControl1 = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.tabPage1 = new System.Windows.Forms.TabPage();
       this.parameterCollectionView = new HeuristicLab.Core.Views.ParameterCollectionView();
@@ -142,5 +142,5 @@
 
     private System.Windows.Forms.Button importButton;
-    private System.Windows.Forms.TabControl tabControl1;
+    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl1;
     private System.Windows.Forms.TabPage tabPage1;
     private System.Windows.Forms.TabPage tabPage2;